package com.yunzhupaas.mdm.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import com.yunzhupaas.base.ActionResult;
import com.yunzhupaas.base.UserInfo;
import com.yunzhupaas.exception.DataException;
import com.yunzhupaas.permission.entity.UserEntity;
import com.yunzhupaas.constant.MsgCode;
import com.yunzhupaas.mdm.service.*;
import com.yunzhupaas.mdm.entity.*;
import com.yunzhupaas.util.*;
import com.yunzhupaas.mdm.model.product.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.yunzhupaas.flowable.entity.TaskEntity;
import jakarta.validation.Valid;
import java.util.*;
import com.yunzhupaas.model.ExcelModel;
import com.yunzhupaas.excel.ExcelExportStyler;
import com.yunzhupaas.excel.ExcelHelper;
import com.yunzhupaas.annotation.YunzhupaasField;
import com.yunzhupaas.base.vo.PageListVO;
import com.yunzhupaas.base.vo.PaginationVO;
import com.yunzhupaas.base.vo.DownloadVO;
import com.yunzhupaas.config.ConfigValueUtil;
import com.yunzhupaas.base.entity.ProvinceEntity;
import java.io.IOException;
import java.util.stream.Collectors;
import com.yunzhupaas.flowable.entity.TaskEntity;
import com.yunzhupaas.exception.WorkFlowException;
import com.yunzhupaas.model.visualJson.UploaderTemplateModel;
import com.yunzhupaas.base.util.FormExecelUtils;
import org.springframework.web.multipart.MultipartFile;
import cn.afterturn.easypoi.excel.ExcelExportUtil;
import cn.afterturn.easypoi.excel.ExcelImportUtil;
import cn.afterturn.easypoi.excel.entity.ExportParams;
import cn.afterturn.easypoi.excel.entity.ImportParams;
import cn.afterturn.easypoi.excel.entity.params.ExcelExportEntity;
import cn.afterturn.easypoi.excel.entity.enmus.ExcelType;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Workbook;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import com.yunzhupaas.onlinedev.model.ExcelImFieldModel;
import com.yunzhupaas.base.model.OnlineImport.ImportDataModel;
import com.yunzhupaas.base.model.OnlineImport.ImportFormCheckUniqueModel;
import com.yunzhupaas.base.model.OnlineImport.ExcelImportModel;
import com.yunzhupaas.base.model.OnlineImport.VisualImportModel;
import cn.xuyanwu.spring.file.storage.FileInfo;
import lombok.Cleanup;
import com.yunzhupaas.model.visualJson.config.HeaderModel;
import com.yunzhupaas.base.model.ColumnDataModel;
import com.yunzhupaas.base.util.VisualUtils;
import org.springframework.transaction.annotation.Transactional;

/**
 * 商品信息
 * @版本： V5.2.7
 * @版权： Copyright @ 2025  深圳市乐程软件有限公司版权所有
 * @作者： 深圳市乐程软件有限公司
 * @日期： 2026-04-27
 */
@Slf4j
@RestController
@Tag(name = "商品信息" , description = "bcm")
@RequestMapping("/api/bcm/Products")
public class ProductsController {

    @Autowired
    private GeneraterSwapUtil generaterSwapUtil;

    @Autowired
    private UserProvider userProvider;

    @Autowired
    private ProductsService productsService;



    @Autowired
    private ConfigValueUtil configValueUtil;

    /**
    * 列表
    *
    * @param productPagination
    * @return
    */
    @Operation(summary = "获取列表")
    @PostMapping("/getList")
    public ActionResult list(@RequestBody ProductPagination productPagination)throws Exception{
        List<ProductEntity> list= productsService.getList(productPagination);
        List<Map<String, Object>> realList=new ArrayList<>();
        for (ProductEntity entity : list) {
        Map<String, Object> productMap=JsonUtil.entityToMap(entity);
        productMap.put("id", productMap.get("product_id"));
        //副表数据
        //子表数据
            realList.add(productMap);
        }
        //数据转换
        boolean isPc = "pc".equals(ServletUtil.getHeader("yunzhupaas-origin" ));
        realList = generaterSwapUtil.swapDataList(realList, ProductsConstant.getFormData(), ProductsConstant.getColumnData(), productPagination.getModuleId(),isPc?false:false);

        //返回对象
        PageListVO vo = new PageListVO();
        vo.setList(realList);
        PaginationVO page = JsonUtil.getJsonToBean(productPagination, PaginationVO.class);
        vo.setPagination(page);
        return ActionResult.success(vo);
    }
    /**
    * 创建
    *
    * @param productForm
    * @return
    */
    @PostMapping()
    @Operation(summary = "创建")
    public ActionResult create(@RequestBody @Valid ProductForm productForm)  {
        String b = productsService.checkForm(productForm,0);
        if (StringUtil.isNotEmpty(b)){
            return ActionResult.fail(b );
        }
        try{
            productsService.saveOrUpdate(productForm, null ,true);
        }catch(Exception e){
            return ActionResult.fail(MsgCode.FA028.get());
        }
        return ActionResult.success(MsgCode.SU001.get());
    }
    /**
    * 导出Excel
    *
    * @return
    */
    @Operation(summary = "导出Excel")
    @PostMapping("/Actions/Export")
    public ActionResult Export(@RequestBody ProductPagination productPagination) throws IOException {
        if (StringUtil.isEmpty(productPagination.getSelectKey())){
            return ActionResult.fail(MsgCode.IMP011.get());
        }
        List<ProductEntity> list= productsService.getList(productPagination);
        List<Map<String, Object>> realList=new ArrayList<>();
        for (ProductEntity entity : list) {
        Map<String, Object> productMap=JsonUtil.entityToMap(entity);
        productMap.put("id", productMap.get("product_id"));
        //副表数据
        //子表数据
            realList.add(productMap);
        }
        //数据转换
        realList = generaterSwapUtil.swapDataList(realList, ProductsConstant.getFormData(), ProductsConstant.getColumnData(), productPagination.getModuleId(),false);
        String[]keys=!StringUtil.isEmpty(productPagination.getSelectKey())?productPagination.getSelectKey():new String[0];
        UserInfo userInfo=userProvider.get();
        String menuFullName = generaterSwapUtil.getMenuName(productPagination.getMenuId());

            DownloadVO vo=this.creatModelExcel(configValueUtil.getTemporaryFilePath(),realList,keys,userInfo,menuFullName);
        return ActionResult.success(vo);
    }

    /**
    * 导出表格方法
    */
    public DownloadVO creatModelExcel(String path,List<Map<String, Object>>list,String[]keys,UserInfo userInfo,String menuFullName){
        DownloadVO vo=DownloadVO.builder().build();
        List<ExcelExportEntity> entitys=new ArrayList<>();
        if(keys.length>0){
            for(String key:keys){
                switch(key){
                    case "product_code" :
                    entitys.add(new ExcelExportEntity("商品编码" ,"product_code"));
                    break;
                    case "product_name" :
                    entitys.add(new ExcelExportEntity("商品名称" ,"product_name"));
                    break;
                    case "product_type" :
                    entitys.add(new ExcelExportEntity("商品类型" ,"product_type"));
                    break;
                    case "product_category" :
                    entitys.add(new ExcelExportEntity("商品分类" ,"product_category"));
                    break;
                    case "short_name" :
                    entitys.add(new ExcelExportEntity("商品简称" ,"short_name"));
                    break;
                    case "brand" :
                    entitys.add(new ExcelExportEntity("品牌" ,"brand"));
                    break;
                    case "product_model" :
                    entitys.add(new ExcelExportEntity("规格型号" ,"product_model"));
                    break;
                    case "color" :
                    entitys.add(new ExcelExportEntity("颜色" ,"color"));
                    break;
                    case "product_size" :
                    entitys.add(new ExcelExportEntity("尺寸/规格" ,"product_size"));
                    break;
                    case "weight" :
                    entitys.add(new ExcelExportEntity("重量" ,"weight"));
                    break;
                    case "min_order_quantity" :
                    entitys.add(new ExcelExportEntity("最小起订量" ,"min_order_quantity"));
                    break;
                    case "standard_sales_price" :
                    entitys.add(new ExcelExportEntity("标准销售单价" ,"standard_sales_price"));
                    break;
                    case "gross_weight" :
                    entitys.add(new ExcelExportEntity("毛重" ,"gross_weight"));
                    break;
                    case "net_weight" :
                    entitys.add(new ExcelExportEntity("净重" ,"net_weight"));
                    break;
                    case "unit_name" :
                    entitys.add(new ExcelExportEntity("单位名称" ,"unit_name"));
                    break;
                    case "packagesize" :
                    entitys.add(new ExcelExportEntity("包装尺寸" ,"packagesize"));
                    break;
                    case "cost_price" :
                    entitys.add(new ExcelExportEntity("成本价" ,"cost_price"));
                    break;
                    case "warranty_period" :
                    entitys.add(new ExcelExportEntity("保修期" ,"warranty_period"));
                    break;
                    case "tax_rate" :
                    entitys.add(new ExcelExportEntity("税率" ,"tax_rate"));
                    break;
                    case "tax_code" :
                    entitys.add(new ExcelExportEntity("税收分类" ,"tax_code"));
                    break;
                    case "warranty_terms" :
                    entitys.add(new ExcelExportEntity("保修条款" ,"warranty_terms"));
                    break;
                    case "remark" :
                    entitys.add(new ExcelExportEntity("备注" ,"remark"));
                    break;
                    default:
                    break;
                }
            }
        }

        ExportParams exportParams = new ExportParams(null, "表单信息");
        exportParams.setType(ExcelType.XSSF);
        try{
            @Cleanup Workbook workbook = new HSSFWorkbook();
            if (entitys.size()>0){
                if (list.size()==0){
                    list.add(new HashMap<>());
                }
                //去除空数据
                List<Map<String, Object>> dataList = new ArrayList<>();
                for (Map<String, Object> map : list) {
                    int i = 0;
                    for (String key : keys) {
                        //子表
                        if (key.toLowerCase().startsWith("tablefield")) {
                            String tableField = key.substring(0, key.indexOf("-" ));
                            String field = key.substring(key.indexOf("-" ) + 1);
                            Object o = map.get(tableField);
                            if (o != null) {
                                List<Map<String, Object>> childList = (List<Map<String, Object>>) o;
                                for (Map<String, Object> childMap : childList) {
                                    if (childMap.get(field) != null) {
                                        i++;
                                    }
                                }
                            }
                        } else {
                            Object o = map.get(key);
                            if (o != null) {
                                i++;
                            }
                        }
                    }
                    if (i > 0) {
                        dataList.add(map);
                    }
                }
                List<ExcelExportEntity> mergerEntitys = new ArrayList<>(entitys);
                List<Map<String, Object>> mergerList=new ArrayList<>(dataList);
                //复杂表头-表头和数据处理
                ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(ProductsConstant.getColumnData(), ColumnDataModel.class);
                List<HeaderModel> complexHeaderList = columnDataModel.getComplexHeaderList();
                if (!Objects.equals(columnDataModel.getType(), 3) && !Objects.equals(columnDataModel.getType(), 5)) {
                    entitys = VisualUtils.complexHeaderHandel(entitys, complexHeaderList, Objects.equals(columnDataModel.getType(), 4));
                    dataList =  VisualUtils.complexHeaderDataHandel(dataList, complexHeaderList, Objects.equals(columnDataModel.getType(), 4));
                }

                exportParams.setStyle(ExcelExportStyler.class);
                workbook = ExcelExportUtil.exportExcel(exportParams, entitys, dataList);
                VisualUtils.mergerVertical(workbook, mergerEntitys, mergerList);
                ExcelModel excelModel = generaterSwapUtil.getExcelParams(ProductsConstant.getFormData(),Arrays.asList(keys));
                ExcelHelper helper = new ExcelHelper();
                helper.init(workbook, exportParams, entitys, excelModel);
                helper.doPreHandle();
                helper.doPostHandle();
            }
            String fileName = menuFullName  +"_"+ DateUtil.dateNow("yyyyMMddHHmmss") + ".xls";
            MultipartFile multipartFile = ExcelUtil.workbookToCommonsMultipartFile(workbook, fileName);
            String temporaryFilePath = configValueUtil.getTemporaryFilePath();
            FileInfo fileInfo = FileUploadUtils.uploadFile(multipartFile, temporaryFilePath, fileName);
            vo.setName(fileInfo.getFilename());
            vo.setUrl(UploaderUtil.uploaderFile(fileInfo.getFilename() + "#" + "Temporary") + "&name=" + fileName);
        } catch (Exception e) {
            log.error("信息导出Excel错误:{}", e.getMessage());
            e.printStackTrace();
        }
        return vo;
    }
    @Operation(summary = "上传文件")
    @PostMapping("/Uploader")
    public ActionResult<Object> Uploader() {
        List<MultipartFile> list = UpUtil.getFileAll();
        MultipartFile file = list.get(0);
        if (file.getOriginalFilename().endsWith(".xlsx") || file.getOriginalFilename().endsWith(".xls")) {
            String filePath = XSSEscape.escape(configValueUtil.getTemporaryFilePath());
            String fileName = XSSEscape.escape(RandomUtil.uuId() + "." + UpUtil.getFileType(file));
            //上传文件
            FileInfo fileInfo = FileUploadUtils.uploadFile(file, filePath, fileName);
            DownloadVO vo = DownloadVO.builder().build();
            vo.setName(fileInfo.getFilename());
            return ActionResult.success(vo);
        } else {
            return ActionResult.fail(MsgCode.FA017.get());
        }
    }

    /**
    * 模板下载
    *
    * @return
    */
    @Operation(summary = "模板下载")
    @GetMapping("/TemplateDownload")
    public ActionResult<DownloadVO>  TemplateDownload(@RequestParam("menuId") String menuId){
        DownloadVO vo = DownloadVO.builder().build();
        UserInfo userInfo = userProvider.get();
        String menuFullName = generaterSwapUtil.getMenuName(menuId);
        //主表对象
        List<ExcelExportEntity> entitys = new ArrayList<>();
        List<String> selectKeys = new ArrayList<>();
        //以下添加字段
                entitys.add(new ExcelExportEntity("商品名称(product_name)" ,"product_name"));
                selectKeys.add("product_name");
                entitys.add(new ExcelExportEntity("商品类型(product_type)" ,"product_type"));
                selectKeys.add("product_type");
                entitys.add(new ExcelExportEntity("商品分类(product_category)" ,"product_category"));
                selectKeys.add("product_category");
                entitys.add(new ExcelExportEntity("商品简称(short_name)" ,"short_name"));
                selectKeys.add("short_name");
                entitys.add(new ExcelExportEntity("品牌(brand)" ,"brand"));
                selectKeys.add("brand");
                entitys.add(new ExcelExportEntity("规格型号(product_model)" ,"product_model"));
                selectKeys.add("product_model");
                entitys.add(new ExcelExportEntity("颜色(color)" ,"color"));
                selectKeys.add("color");
                entitys.add(new ExcelExportEntity("尺寸/规格(product_size)" ,"product_size"));
                selectKeys.add("product_size");
                entitys.add(new ExcelExportEntity("重量(weight)" ,"weight"));
                selectKeys.add("weight");
                entitys.add(new ExcelExportEntity("最小起订量(min_order_quantity)" ,"min_order_quantity"));
                selectKeys.add("min_order_quantity");
                entitys.add(new ExcelExportEntity("标准销售单价(standard_sales_price)" ,"standard_sales_price"));
                selectKeys.add("standard_sales_price");
                entitys.add(new ExcelExportEntity("毛重(gross_weight)" ,"gross_weight"));
                selectKeys.add("gross_weight");
                entitys.add(new ExcelExportEntity("净重(net_weight)" ,"net_weight"));
                selectKeys.add("net_weight");
                entitys.add(new ExcelExportEntity("单位名称(unit_name)" ,"unit_name"));
                selectKeys.add("unit_name");
                entitys.add(new ExcelExportEntity("包装尺寸(packagesize)" ,"packagesize"));
                selectKeys.add("packagesize");
                entitys.add(new ExcelExportEntity("成本价(cost_price)" ,"cost_price"));
                selectKeys.add("cost_price");
                entitys.add(new ExcelExportEntity("保修期(warranty_period)" ,"warranty_period"));
                selectKeys.add("warranty_period");
                entitys.add(new ExcelExportEntity("税率(tax_rate)" ,"tax_rate"));
                selectKeys.add("tax_rate");
                entitys.add(new ExcelExportEntity("税收分类(tax_code)" ,"tax_code"));
                selectKeys.add("tax_code");
                entitys.add(new ExcelExportEntity("保修条款(warranty_terms)" ,"warranty_terms"));
                selectKeys.add("warranty_terms");
                entitys.add(new ExcelExportEntity("备注(remark)" ,"remark"));
                selectKeys.add("remark");
        ExcelModel excelModel = generaterSwapUtil.getExcelParams(ProductsConstant.getFormData(),selectKeys);
        List<Map<String, Object>> list = new ArrayList<>();
        list.add(excelModel.getDataMap());

        ExportParams exportParams = new ExportParams(null, menuFullName + "模板");
        exportParams.setStyle(ExcelExportStyler.class);
        exportParams.setType(ExcelType.XSSF);
        try{
        @Cleanup Workbook workbook = new HSSFWorkbook();
        if (entitys.size()>0){
            if (list.size()==0){
                list.add(new HashMap<>());
            }
            //复杂表头-表头和数据处理
            ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(ProductsConstant.getColumnData(), ColumnDataModel.class);
            List<HeaderModel> complexHeaderList = columnDataModel.getComplexHeaderList();
            if (!Objects.equals(columnDataModel.getType(), 3) && !Objects.equals(columnDataModel.getType(), 5)) {
                entitys = VisualUtils.complexHeaderHandel(entitys, complexHeaderList, false);
                list =  VisualUtils.complexHeaderDataHandel(list, complexHeaderList, false);
            }
            workbook = ExcelExportUtil.exportExcel(exportParams, entitys, list);
            ExcelHelper helper = new ExcelHelper();
            helper.init(workbook, exportParams, entitys, excelModel);
            helper.doPreHandle();
            helper.doPostHandle();
        }
        String fileName = menuFullName + "导入模板.xls";
        MultipartFile multipartFile = ExcelUtil.workbookToCommonsMultipartFile(workbook, fileName);
            String temporaryFilePath = configValueUtil.getTemporaryFilePath();
            FileInfo fileInfo = FileUploadUtils.uploadFile(multipartFile, temporaryFilePath, fileName);
        vo.setName(fileInfo.getFilename());
        vo.setUrl(UploaderUtil.uploaderFile(fileInfo.getFilename() + "#" + "Temporary") + "&name=" + fileName);
        } catch (Exception e) {
        log.error("模板信息导出Excel错误:{}", e.getMessage());
        e.printStackTrace();
        }
        return ActionResult.success(vo);
    }

    /**
    * 导入预览
    *
    * @return
    */
    @Operation(summary = "导入预览" )
    @GetMapping("/ImportPreview")
    public ActionResult<Map<String, Object>> ImportPreview(String fileName) throws Exception {
        Map<String, Object> headAndDataMap = new HashMap<>(2);
            String filePath = FileUploadUtils.getLocalBasePath() + configValueUtil.getTemporaryFilePath();
            FileUploadUtils.downLocal(configValueUtil.getTemporaryFilePath(), filePath, fileName);
        File temporary = new File(XSSEscape.escapePath(filePath + fileName));
            int headerRowIndex = 1;
        ImportParams params = new ImportParams();
        params.setTitleRows(0);
        params.setHeadRows(headerRowIndex);
        params.setNeedVerify(true);
        try {
            InputStream inputStream = ExcelUtil.solveOrginTitle(temporary, headerRowIndex);
            List<Map> excelDataList = ExcelUtil.importExcelByInputStream(inputStream, 0, headerRowIndex, Map.class);
            //数据超过1000条
            if(excelDataList != null && excelDataList.size() > 1000) {
                return ActionResult.fail(MsgCode.ETD117.get());
            }

            ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(ProductsConstant.getColumnData(), ColumnDataModel.class);
            UploaderTemplateModel uploaderTemplateModel = JsonUtil.getJsonToBean(columnDataModel.getUploaderTemplateJson(), UploaderTemplateModel.class);
            List<String> selectKey = uploaderTemplateModel.getSelectKey();
            //子表合并
            List<Map<String, Object>> results = FormExecelUtils.dataMergeChildTable(excelDataList,selectKey);
            // 导入字段
            List<ExcelImFieldModel> columns = new ArrayList<>();
            columns.add(new ExcelImFieldModel("product_name","商品名称","input"));
            columns.add(new ExcelImFieldModel("product_type","商品类型","select"));
            columns.add(new ExcelImFieldModel("product_category","商品分类","cascader"));
            columns.add(new ExcelImFieldModel("short_name","商品简称","input"));
            columns.add(new ExcelImFieldModel("brand","品牌","input"));
            columns.add(new ExcelImFieldModel("product_model","规格型号","input"));
            columns.add(new ExcelImFieldModel("color","颜色","input"));
            columns.add(new ExcelImFieldModel("product_size","尺寸/规格","input"));
            columns.add(new ExcelImFieldModel("weight","重量","input"));
            columns.add(new ExcelImFieldModel("min_order_quantity","最小起订量","inputNumber"));
            columns.add(new ExcelImFieldModel("standard_sales_price","标准销售单价","inputNumber"));
            columns.add(new ExcelImFieldModel("gross_weight","毛重","inputNumber"));
            columns.add(new ExcelImFieldModel("net_weight","净重","inputNumber"));
            columns.add(new ExcelImFieldModel("unit_name","单位名称","input"));
            columns.add(new ExcelImFieldModel("packagesize","包装尺寸","input"));
            columns.add(new ExcelImFieldModel("cost_price","成本价","inputNumber"));
            columns.add(new ExcelImFieldModel("warranty_period","保修期","inputNumber"));
            columns.add(new ExcelImFieldModel("tax_rate","税率","select"));
            columns.add(new ExcelImFieldModel("tax_code","税收分类","cascader"));
            columns.add(new ExcelImFieldModel("warranty_terms","保修条款","textarea"));
            columns.add(new ExcelImFieldModel("remark","备注","textarea"));
            headAndDataMap.put("dataRow" , results);
            headAndDataMap.put("headerRow" , JsonUtil.getJsonToList(JsonUtil.getListToJsonArray(columns)));
            } catch (Exception e){
            e.printStackTrace();
            return ActionResult.fail(MsgCode.VS407.get());
        }
        return ActionResult.success(headAndDataMap);
    }

    /**
    * 导入数据
    *
    * @return
    */
    @Operation(summary = "导入数据" )
    @PostMapping("/ImportData")
    public ActionResult<ExcelImportModel> ImportData(@RequestBody VisualImportModel visualImportModel) throws Exception {
        List<Map<String, Object>> listData = visualImportModel.getList();
        ImportFormCheckUniqueModel uniqueModel = new ImportFormCheckUniqueModel();
        uniqueModel.setDbLinkId(ProductsConstant.DBLINKID);
        uniqueModel.setUpdate(Objects.equals("2", "2"));

        Map<String,String> tablefieldkey = new HashMap<>();
        for(String key:ProductsConstant.TABLEFIELDKEY.keySet()){
        tablefieldkey.put(key,ProductsConstant.TABLERENAMES.get(ProductsConstant.TABLEFIELDKEY.get(key)));
        }
        ExcelImportModel excelImportModel = generaterSwapUtil.importData(ProductsConstant.getFormData(),listData,uniqueModel, tablefieldkey,ProductsConstant.getTableList());
        List<ImportDataModel> importDataModel = uniqueModel.getImportDataModel();
        for (ImportDataModel model : importDataModel) {
            String id = model.getId();
            Map<String, Object> result = model.getResultData();
            if(StringUtil.isNotEmpty(id)){
                update(id, JsonUtil.getJsonToBean(result,ProductForm.class), true);
            }else {
                create( JsonUtil.getJsonToBean(result,ProductForm.class));
            }
        }
        return ActionResult.success(excelImportModel);
    }

    /**
    * 导出异常报告
    *
    * @return
    */
    @Operation(summary = "导出异常报告")
    @PostMapping("/ImportExceptionData")
    public ActionResult<DownloadVO> ImportExceptionData(@RequestBody VisualImportModel visualImportModel) {
        DownloadVO vo = DownloadVO.builder().build();
        UserInfo userInfo = userProvider.get();
        String menuFullName = generaterSwapUtil.getMenuName(visualImportModel.getMenuId());
        //主表对象
        List<ExcelExportEntity> entitys = new ArrayList<>();
        entitys.add(new ExcelExportEntity("异常原因", "errorsInfo",30));
        List<String> selectKeys = new ArrayList<>();
        //以下添加字段
                entitys.add(new ExcelExportEntity("商品名称(product_name)" ,"product_name"));
                selectKeys.add("product_name");
                entitys.add(new ExcelExportEntity("商品类型(product_type)" ,"product_type"));
                selectKeys.add("product_type");
                entitys.add(new ExcelExportEntity("商品分类(product_category)" ,"product_category"));
                selectKeys.add("product_category");
                entitys.add(new ExcelExportEntity("商品简称(short_name)" ,"short_name"));
                selectKeys.add("short_name");
                entitys.add(new ExcelExportEntity("品牌(brand)" ,"brand"));
                selectKeys.add("brand");
                entitys.add(new ExcelExportEntity("规格型号(product_model)" ,"product_model"));
                selectKeys.add("product_model");
                entitys.add(new ExcelExportEntity("颜色(color)" ,"color"));
                selectKeys.add("color");
                entitys.add(new ExcelExportEntity("尺寸/规格(product_size)" ,"product_size"));
                selectKeys.add("product_size");
                entitys.add(new ExcelExportEntity("重量(weight)" ,"weight"));
                selectKeys.add("weight");
                entitys.add(new ExcelExportEntity("最小起订量(min_order_quantity)" ,"min_order_quantity"));
                selectKeys.add("min_order_quantity");
                entitys.add(new ExcelExportEntity("标准销售单价(standard_sales_price)" ,"standard_sales_price"));
                selectKeys.add("standard_sales_price");
                entitys.add(new ExcelExportEntity("毛重(gross_weight)" ,"gross_weight"));
                selectKeys.add("gross_weight");
                entitys.add(new ExcelExportEntity("净重(net_weight)" ,"net_weight"));
                selectKeys.add("net_weight");
                entitys.add(new ExcelExportEntity("单位名称(unit_name)" ,"unit_name"));
                selectKeys.add("unit_name");
                entitys.add(new ExcelExportEntity("包装尺寸(packagesize)" ,"packagesize"));
                selectKeys.add("packagesize");
                entitys.add(new ExcelExportEntity("成本价(cost_price)" ,"cost_price"));
                selectKeys.add("cost_price");
                entitys.add(new ExcelExportEntity("保修期(warranty_period)" ,"warranty_period"));
                selectKeys.add("warranty_period");
                entitys.add(new ExcelExportEntity("税率(tax_rate)" ,"tax_rate"));
                selectKeys.add("tax_rate");
                entitys.add(new ExcelExportEntity("税收分类(tax_code)" ,"tax_code"));
                selectKeys.add("tax_code");
                entitys.add(new ExcelExportEntity("保修条款(warranty_terms)" ,"warranty_terms"));
                selectKeys.add("warranty_terms");
                entitys.add(new ExcelExportEntity("备注(remark)" ,"remark"));
                selectKeys.add("remark");
        ExcelModel excelModel = generaterSwapUtil.getExcelParams(ProductsConstant.getFormData(),selectKeys);
        List<Map<String, Object>> list = new ArrayList<>();
        list.addAll(visualImportModel.getList());

        ExportParams exportParams = new ExportParams(null, menuFullName + "模板");
        exportParams.setStyle(ExcelExportStyler.class);
        exportParams.setType(ExcelType.XSSF);
        exportParams.setFreezeCol(1);
        try{
            @Cleanup Workbook workbook = new HSSFWorkbook();
            if (entitys.size()>0){
                if (list.size()==0){
                    list.add(new HashMap<>());
                }
                //复杂表头-表头和数据处理
                ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(ProductsConstant.getColumnData(), ColumnDataModel.class);
                List<HeaderModel> complexHeaderList = columnDataModel.getComplexHeaderList();
                if (!Objects.equals(columnDataModel.getType(), 3) && !Objects.equals(columnDataModel.getType(), 5)) {
                    entitys = VisualUtils.complexHeaderHandel(entitys, complexHeaderList, false);
                    list =  VisualUtils.complexHeaderDataHandel(list, complexHeaderList, false);
                }

                workbook = ExcelExportUtil.exportExcel(exportParams, entitys, list);
                ExcelHelper helper = new ExcelHelper();
                helper.init(workbook, exportParams, entitys, excelModel);
                helper.doPreHandle();
                helper.doPostHandle();
            }

            String fileName = menuFullName + "错误报告_" + DateUtil.dateNow("yyyyMMddHHmmss") + ".xls";
            MultipartFile multipartFile = ExcelUtil.workbookToCommonsMultipartFile(workbook, fileName);
            String temporaryFilePath = configValueUtil.getTemporaryFilePath();
            FileInfo fileInfo = FileUploadUtils.uploadFile(multipartFile, temporaryFilePath, fileName);
            vo.setName(fileInfo.getFilename());
            vo.setUrl(UploaderUtil.uploaderFile(fileInfo.getFilename() + "#" + "Temporary") + "&name=" + fileName);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ActionResult.success(vo);
    }
    /**
    * 删除
    * @param id
    * @return
    */
    @Operation(summary = "删除")
    @DeleteMapping("/{id}")
    @Transactional
    public ActionResult delete(@PathVariable("id") String id,@RequestParam(name = "forceDel",defaultValue = "false") boolean forceDel) throws Exception{
        ProductEntity entity= productsService.getInfo(id);
        if(entity!=null){
            //假删除
            entity.setDeleteMark(1);
            entity.setDeleteUserId(userProvider.get().getUserId());
            entity.setDeleteTime(new Date());
            productsService.setIgnoreLogicDelete().updateById(entity);
        }
        return ActionResult.success(MsgCode.SU003.get());
    }
    /**
    * 批量删除
    * @param obj
    * @return
    */
    @DeleteMapping("/batchRemove")
    @Transactional
    @Operation(summary = "批量删除")
    public ActionResult batchRemove(@RequestBody Object obj){
    Map<String, Object> objectMap = JsonUtil.entityToMap(obj);
    List<String> idList = JsonUtil.getJsonToList(objectMap.get("ids"), String.class);
    String errInfo = "";
    List<String> successList = new ArrayList<>();
        for (String allId : idList){
            try {
                this.delete(allId,false);
                successList.add(allId);
            } catch (Exception e) {
                errInfo = e.getMessage();
            }
        }
        if (successList.size() == 0 && StringUtil.isNotEmpty(errInfo)){
            return ActionResult.fail(errInfo);
        }
        return ActionResult.success(MsgCode.SU003.get());
    }
    /**
    * 编辑
    * @param id
    * @param productForm
    * @return
    */
    @PutMapping("/{id}")
    @Operation(summary = "更新")
    public ActionResult update(@PathVariable("id") String id,@RequestBody @Valid ProductForm productForm,
                                @RequestParam(value = "isImport", required = false) boolean isImport){
        ProductEntity entity= productsService.getInfo(id);
        if(entity!=null){
            productForm.setProductId(String.valueOf(entity.getProductId()));

            if (!isImport) {
                String b =  productsService.checkForm(productForm,1);
                if (StringUtil.isNotEmpty(b)){
                    return ActionResult.fail(b );
                }
            }

            try{
                productsService.saveOrUpdate(productForm,id,false);
            }catch (DataException e1){
                return ActionResult.fail(e1.getMessage());
            }catch(Exception e){
                return ActionResult.fail(MsgCode.FA029.get());
            }
            return ActionResult.success(MsgCode.SU004.get());
        }else{
            return ActionResult.fail(MsgCode.FA002.get());
        }
    }
    /**
    * 表单信息(详情页)
    * 详情页面使用-转换数据
    * @param id
    * @return
    */
    @Operation(summary = "表单信息(详情页)")
    @GetMapping("/detail/{id}")
    public ActionResult detailInfo(@PathVariable("id") String id){
        ProductEntity entity= productsService.getInfo(id);
        if(entity==null){
            return ActionResult.fail(MsgCode.FA001.get());
        }
        Map<String, Object> productMap=JsonUtil.entityToMap(entity);
        productMap.put("id", productMap.get("product_id"));
        //副表数据
        //子表数据
        boolean isPc = "pc".equals(ServletUtil.getHeader("yunzhupaas-origin" ));
        productMap = generaterSwapUtil.swapDataDetail(productMap,ProductsConstant.getFormData(),"817386322065883909",isPc?false:false);
        //子表数据
        return ActionResult.success(productMap);
    }
    /**
    * 获取详情(编辑页)
    * 编辑页面使用-不转换数据
    * @param id
    * @return
    */
    @Operation(summary = "信息")
    @GetMapping("/{id}")
    public ActionResult info(@PathVariable("id") String id){
        ProductEntity entity= productsService.getInfo(id);
        if(entity==null){
            return ActionResult.fail(MsgCode.FA001.get());
        }
        Map<String, Object> productMap=JsonUtil.entityToMap(entity);
        productMap.put("id", productMap.get("product_id"));
        //副表数据
        //子表数据
        productMap = generaterSwapUtil.swapDataForm(productMap,ProductsConstant.getFormData(),ProductsConstant.TABLEFIELDKEY,ProductsConstant.TABLERENAMES);
        return ActionResult.success(productMap);
    }

}
